#ifndef _BsCurv_H_
#define _BsCurv_H_

#include "vector.h"
#include "matrix.h"

class BsCurv
//class Nurbs
{
public:
	Matrix* _pCtrPoint;   //조정점을 저장
	Vector* _pKnot;       //knot Vector를 저장
	Vector* _pParamValue; //점데이터를 가지고 작업하는경우 파라메터 값
	Vector* _pWeight;     //각 CP의 weight를 저장
	Vector* _pError;      //근사했을때 각 점으로부터의 deviation
	Vector* _pUp;         //point project한 파라메터값을 저장
	int _p; //degree
	int _n; //basis funs 개수-1 or control point-1 

	//void CalRK(void);
public :
	BsCurv(void);
	BsCurv(int n, int p, Matrix& ctrp, Vector& knot);
	BsCurv(int n , int p, Matrix& ctrp);
	BsCurv(int n , int p);
	~BsCurv(void);
	void InitObject(int n, int p);
	void InitObject(int n, int p, Matrix& ctrp, Vector& knot);
	int FindSpan(double u);
	void BasisFuns(int i, double u, Vector& N);
	void OneBasisFuns(int i, double u, double& Nip);
	void DerBasisFuns(int i, double u, int n, Matrix& Ders);
	void CurvePoint(double u, Vector& C);
	void CurvePointR(double u, Vector& C);
	void CurveDerivsAlg1(double u, int d, Matrix& CK);
	void CurveDerivCpts(int d, Matrix** PK);
	void GenKnotVector4App(int n, int p, Vector& Param);
	void GenParamValue(Matrix& Q);
	void LeastSquareCurve(Matrix& Q);
	void LeastSquareCurveErrBnd(Matrix& Q, int p, double Tol);
	void InterpolCurve(Matrix& Q, Vector* param='\0');
	void CalRK(Matrix& rk, Matrix& Q);
	void CurveKnotIns(double u, int k, int s, int r);
	void RefineKnotVectCurve(Vector& X, int r);
	void GetRemovalBndCurve(double u, int r, int s, double& Br);
	void RemoveCurveKnot(double u, int r, int s, int num, double tol, int& t);
	void RemoveCurveKnotWithoutErr(double u, int r, int s, int num, int& t);
	void RemoveErrBnd(double tol);
	void RemoveCurveKnot4App(Matrix& Q, double tol);
	void RemoveOneKnot4App(Matrix& Q, int r, double tol);
	bool IsRemoveOneKnot4App(Matrix& Q, int r, double tol);
	void CalKnotSpan(int n);
	void PointProject(Vector& P, double& up);
	bool PointProject(Vector& P, int index, double& up);
	void RefineKnotVectAllCurve(Vector mkv);
	void RefineData(Matrix& Q);
	void Colinear(void);
	//void GetSplitSize(double us, int& clc, int& clk, int& crc, int& crk);
	//void GetSplitSize(int n, int& c, int& k);
	//void SplitCurve(double us, Matrix& CLC, Vector& CLK, Matrix& CRC, Vector& CRK);
	////void SPlitCurve(int n, Matrix& SCP, Vector& SCU);
	//void FindSplitBound(int n, double& low, double& high);

	friend void MergeKnotVect(BsCurv* nurbslist, int l, int p);
	friend void UdirKnotParam(BsCurv* nurbslist, int l, Vector& v);
	friend void RemoveKnotSectionCurves(BsCurv* LSC, int num_curve, Matrix** Q, double tol2);
};

#endif

