#ifndef _BsSurf_H_
#define _BsSurf_H_

#include "vector.h"
#include "matrix.h"
#include "bscurv.h"

class BsSurf
{
	public:
		int _n, _p, _m, _q;
		BsCurv* m_pUdir;
		BsCurv* m_pVdir;

		Matrix *m_pXcoord, *m_pYcoord, *m_pZcoord;

	public:
		BsSurf(int n, int p, Vector& U, int m, int q, Vector& V,
				Matrix& x, Matrix& y, Matrix& z);
		~BsSurf(void);

		void SurfacePoint(double u, double v,Vector& S);
		void SurfaceDerivsAlg1(double u, double v, int d, Matrix** SKL);
		void GetUdirDerivsCP(int i, Matrix& CP);
};

void RearrangeforOnecoord(Matrix** from, Matrix** to, int size);

#endif
